//
//  ViewController.m
//  OS_X_testView
//
//  Created by SF639 on 2015/5/7.
//  Copyright (c) 2015年 GoDEX. All rights reserved.
//

#import "ViewController.h"

@interface ViewController()
@property (strong) IBOutlet NSTextField *sn;
@property (strong) IBOutlet NSTextField *ip;
@property (strong) IBOutlet NSTextField *command;
@property (strong) IBOutlet NSTextView *message;

@property (strong, nonatomic) GoDEXPrinterControl *godex;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    // Do any additional setup after loading the view.
    
    _sn.placeholderString = @"input printer serial number"; //eg. 20140108
    _ip.placeholderString = @"input printer IP address";    //eg. 192.168.102.100

    _command.placeholderString = @"Command";
    
    _message.editable = NO;
    
    _godex = [[GoDEXPrinterControl alloc] init];
}

- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];

    // Update the view, if already loaded.
}

- (IBAction)connect:(id)sender
{
    
    if ([_godex openUSB:[_sn stringValue]]) {
        NSLog(@"USB 連線成功");
    } else if ([_godex openNet:[_ip stringValue] port:9100]) {
        NSLog(@"Net 連線成功");
    } else {
        NSLog(@"連線失敗");
    }
}

- (IBAction)disconnect:(id)sender
{
    [_godex close];
}

- (IBAction)send:(id)sender
{
    if ([_godex sendCommand:[_command stringValue]]) {
        NSString *readMessage = [_godex read];
        if (readMessage != nil) {
            [_message setString:readMessage];
        }
    } else {
        [_message setString:@""];
    }
}

- (IBAction)scanNetPrinter:(id)sender
{
    NSLog(@"%@", [_godex findAllNet]);
}

- (IBAction)scanUSBDevice:(id)sender
{
    NSLog(@"%@", [_godex findAllUSB]);
}

- (IBAction)printSampleLabel:(id)sender
{
    NSString *path = [[NSBundle mainBundle] pathForResource:@"RT700i" ofType:@"bmp"];
    
    [_godex setup:40 gap:2 top:0 dark:10 speed:2 mode:1];
    [_godex sendCommand:@"^P1"];
    [_godex sendCommand:@"~MDELGimage1"];
    [_godex loadImage:path imageID:@"image1"];
    [_godex sendCommand:@"^L"];
    [_godex sendCommand:@"Y0,0,image1"];
    [_godex sendCommand:@"E"];
}

- (IBAction)printCmdFile:(id)sender
{
    NSString *path = [[NSBundle mainBundle] pathForResource:@"testFile" ofType:@"txt"];
    
    [_godex printCmdFile:path];
}

@end
