//
//  GoDEXControl.h
//  godextool
//
//  Created by SF639 on 2015/4/23.
//  Copyright (c) 2015年 GoDEX. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Foundation/Foundation.h>

typedef enum {
    GapLabel = 0,
    PlainPaper = 1,
    BlackMarkLabel = 2
} MediaType;

typedef enum {
    USB = 0,
    Net = 1
} PortID;

typedef struct ARGBPixel {
    unsigned char a;
    unsigned char r;
    unsigned char g;
    unsigned char b;
} ARGBPixel;

typedef struct RGBPixel {
    unsigned char r;
    unsigned char g;
    unsigned char b;
} RGBPixel;

#define BITS_PER_COMPONENT 8
#define _32_BYTE_PER_PIXEL 4
#define _24_BYTE_PER_PIXEL 3

@interface GoDEXPrinterControl : NSObject

@property(nonatomic, strong) NSString *version;

- (BOOL)openNet:(NSString *)address port:(NSInteger)port;
- (BOOL)openNet:(NSString *)address port:(NSInteger)port timeout:(NSInteger)timeout;
- (BOOL)openUSB:(NSString *)serialNumber;
- (void)close;

- (BOOL)sendCommand:(NSString *)command;
- (BOOL)sendCommand:(NSString *)command encoding:(NSInteger)encode;

- (NSString *)read;
- (NSString *)read:(NSInteger)timeout;

- (NSArray *)findAllNet;
- (NSArray *)findAllUSB;

- (BOOL)setup:(NSInteger)height
          gap:(NSInteger)gap
          top:(NSInteger)top
         dark:(NSInteger)dark
        speed:(NSInteger)speed
         mode:(NSInteger)mode;

- (BOOL)printCmdFile:(NSString *)fileName;
- (BOOL)loadImage:(NSString *)fileName imageID:(NSString *)imageID;
- (BOOL)putImage:(NSString *)fileName pointX:(NSInteger)px pointY:(NSInteger)py;
@end
