//
//  ViewController.swift
//  OS_X_testView_by_swift
//
//  Created by SF639 on 2015/4/30.
//  Copyright (c) 2015年 GoDEX. All rights reserved.
//

import Cocoa

class ViewController: NSViewController {
    @IBOutlet var ip: NSTextField!
    @IBOutlet var sn: NSTextField!
    @IBOutlet var command: NSTextField!
    @IBOutlet var message: NSTextView!

    var godex = GoDEXPrinterControl()
    var array = NSArray()
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        sn.placeholderString = "input printer serial number"; //eg. 20140108
        ip.placeholderString = "input printer IP address";    //eg. 192.168.102.100
        command.placeholderString = "Command"
        
        message.editable = false
    }

    override var representedObject: AnyObject? {
        didSet {
        // Update the view, if already loaded.
        }
    }

    @IBAction func connect(sender: NSButton)
    {
        if (godex.openUSB(sn.stringValue)) {
            println("USB 連線成功");
        } else if (godex.openNet(ip.stringValue, port: 9100)) {
            println("Net 連線成功");
        } else {
            println("連線失敗");
        }
    }
    
    @IBAction func disconnect(sender: NSButton)
    {
        godex.close()
    }
    
    @IBAction func sendCommand(sender: NSButton)
    {
        if godex.sendCommand(command.stringValue) {
            var readMessage = godex.read()
            if (readMessage != nil) {
                message.string = readMessage
            }
        } else {
            message.string = ""
        }
    }
    
    @IBAction func printSampleLabel(sender: NSButton)
    {
        var path = NSBundle.mainBundle().pathForResource("testFile", ofType: "txt")
        
        godex.printCmdFile(path)
    }
    
    @IBAction func printCmdFile(sender: NSButton)
    {
        var path = NSBundle.mainBundle().pathForResource("RT700i", ofType: "bmp")
        
        godex.setup(40, gap: 2, top: 0, dark: 10, speed: 2, mode: 1)
        godex.sendCommand("^P1")
        godex.sendCommand("~MDELG,image1")
        godex.loadImage(path, imageID: "image1")
        godex.sendCommand("^L")
        godex.sendCommand("Y0,0,image1")
        godex.sendCommand("E")
    }
    
    @IBAction func scanNetPrinter(sender: NSButton)
    {
        println("\(godex.findAllNet())")
    }
    
    @IBAction func scanUSBDevices(sender: NSButton)
    {
        println("\(godex.findAllUSB())")
    }
    
}

